
<template>
  <div>
    <!-- Table Container Card -->
    <b-card no-body class="mb-0">
      <div class="m-2">
        <validation-observer ref="simpleRules">
          <b-form @submit.prevent>
            <div class="title">
              <h4>Agregar usuario</h4>
            </div>

            <br />
            <div v-for="(alert, idx) in errors" :key="idx">
                <b-alert variant="warning" :show="true" >{{alert[0]}}</b-alert> 
       
            </div>

            <b-row>
              <b-col cols="6">
                <div class="d-flex">
                  <feather-icon icon="UserIcon" size="19" />
                  <h4 class="mb-0 ml-50">Información Personal</h4>
                </div>
              </b-col>

              <b-col cols="6">
                <div class="d-flex">
                  <feather-icon icon="UserIcon" size="19" />
                  <h4 class="mb-0 ml-50">Información de usuario</h4>
                </div>
              </b-col>
            </b-row>
            <br>

            <b-row>
              <b-col cols="6">
                <b-form-group label="Nombres(s)" label-for="name">
                  <b-form-input
                    v-model="user.name"
                    trim
                    :state="validationName"
                    placeholder="Nombre"
                    maxlength="60"
                  />
                  <b-form-invalid-feedback :state="validationName">
                    Este campo es obligatorio
                </b-form-invalid-feedback>
                </b-form-group>

                 <b-form-group label="Apellido(s)" label-for="last_name">
                    <b-form-input
                      id="last_name"
                      v-model="user.last_name"
                      trim
                      :state="validationLastName"
                      placeholder="Apellido(s)"
                      maxlength="60"
                    />
                    <b-form-invalid-feedback :state="validationLastName">
                      Este campo es obligatorio
                    </b-form-invalid-feedback>
                </b-form-group>

                <b-form-group label="Teléfono" label-for="phone">
                    <b-form-input
                      id="phone"
                      type="number"
                      v-model="user.phone"
                      trim
                      :state="validationPhone"
                      placeholder="Teléfono(s)"
                      onKeyUp=" if (this.value.length > 10) this.value = this.value.slice(0, 10)"
                    />
                    <b-form-invalid-feedback :state="validationPhone">
                      Ingrese el teléfono correctamente
                    </b-form-invalid-feedback>
                </b-form-group>

                <b-form-group label="Dirección" label-for="address">

                    <b-form-input
                      id="address"
                      v-model="user.address"
                      trim
                      :state="validationAddress"
                      placeholder="Dirección"
                      maxlength="30"
                    />
                    <b-form-invalid-feedback :state="validationAddress">
                      Este campo es obligatorio
                    </b-form-invalid-feedback>
                </b-form-group>

                <b-form-group label="Puesto" label-for="job">

                    <b-form-input
                      id="job"
                      v-model="user.job"
                      trim
                      :state="validationJob"
                       placeholder="Puesto"
                       maxlength="25"
                    />
                    <b-form-invalid-feedback :state="validationJob">
                      Este campo es obligatorio
                    </b-form-invalid-feedback>
                </b-form-group>
                
               <b-form-group label="Imagen" label-for="image">

                  <b-form-file
                    v-model="user.image"
                    accept="image/*"
                    placeholder="Seleccionar un imagen..."
                    drop-placeholder="Drop file here..."
                    @change="previewImage"
                  />
                </b-form-group>
              </b-col>

              <!-- -------------------------------------- -->

               <b-col cols="6">
                
                <b-form-group label="Nombre de usuario" label-for="nickname">
                    <b-form-input
                      id="nickname"
                      v-model="user.nickname"
                      trim
                      :state="validationUsername"
                      placeholder="Nombre de usuario"
                      maxlength="10"
                    />
                    <b-form-invalid-feedback :state="validationUsername">
                      Este campo es obligatorio
                    </b-form-invalid-feedback>
                </b-form-group>

                <b-form-group label="Email" label-for="v-email">
                    <b-form-input
                      id="v-email"
                      v-model="user.email"
                      type="email"
                      trim
                      :state="validationEmail"
                      placeholder="Email"
                      maxlength="50"
                    />
                    <b-form-invalid-feedback :state="validationEmail">
                      Ingrese el formato correcto para el email
                    </b-form-invalid-feedback>
                </b-form-group>

            
                <b-form-group label="Password" label-for="password">
                    <b-form-input
                      id="password"
                      type="password"
                      v-model="user.password"
                      trim
                      placeholder="Password"
                      maxlength="40"
                    />
          
                </b-form-group>
                <br>
                <div v-if="image">
                  <b-avatar  :src="baseURL+image" size="200px" rounded />
                </div>
                <div v-else>
                  <b-avatar :src="preview" size="200px" rounded />
                </div>
              </b-col>
            </b-row>
            <br>
          <b-card
          no-body
          class="border mt-1"
          style="max-width: 55rem;"
          
          >
          <b-card-header class="p-1">
            <b-card-title class="font-medium-2">
              <feather-icon
                icon="LockIcon"
                size="18"
              />
              <span class="align-middle ml-50">Permisos</span>
            </b-card-title>
          </b-card-header>
            
             <b-card-text>
              <b-col >
                <permissions-table :permissions="user.permissions"   ></permissions-table>
              </b-col>
            </b-card-text>

          </b-card>
            <b-row>
              <b-col cols="6">
                <b-button
                  v-ripple.400="'rgba(255, 255, 255, 0.15)'"
                  type="submit"
                  variant="primary"
                  class="mr-1"
                  :disabled="lockedSubmit.name || lockedSubmit.last_name ||lockedSubmit.phone || lockedSubmit.address || lockedSubmit.job || lockedSubmit.username || lockedSubmit.email"
                  @click="updateUser()"
                >
                  Guardar
                </b-button>
                <b-button
                  v-ripple.400="'rgba(186, 191, 199, 0.15)'"
                  type="reset"
                  variant="outline-secondary"
                  :to="{ name: 'apps-users-list' }"
                >
                  Cancelar
                </b-button>
              </b-col>
            </b-row>
          </b-form>
        </validation-observer>
      </div>
    </b-card>
  </div>
</template>

<script>
import BCardCode from "@core/components/b-card-code";
import { ValidationProvider, ValidationObserver } from 'vee-validate'
import {
  BCard,
  BRow,
  BCol,
  BFormGroup,
  BFormInput,
  BFormFile,
  BFormCheckbox,
  BForm,
  BButton,
  BAlert,
  BInputGroupPrepend,
  BAvatar,
  BCardText,
  BCardHeader,
  BCardTitle,
  BFormInvalidFeedback,
} from "bootstrap-vue";
import Ripple from "vue-ripple-directive";
import Cleave from "vue-cleave-component";
import { required, email } from '@validations'
import PermissionsTable from '../../roles/PermissionsTables.vue'
export default {
  components: {
    BCard,
    BCardCode,
    BRow,
    BCol,
    BFormGroup,
    BFormInput,
    BFormFile,
    BFormCheckbox,
    BForm,
    BButton,
    BAlert,
    BInputGroupPrepend,
    Cleave,
    BAvatar,
    ValidationProvider,
    ValidationObserver,
    PermissionsTable,
    BCardText,
    BCardHeader,
    BCardTitle,
    BFormInvalidFeedback
  },
  directives: {
    Ripple,
  },
  data: () => ({
    user: {
      id: "",
      name: "",
      last_name: "",
      phone: "",
      address: "",
      nickname: "",
      job: "",
      email: "",
      password: null,
      image: null,
      permissions:[{permissionId:'1',selected:false},{permissionId:'2',selected:false},{permissionId:'3',selected:false},
          {permissionId:'4',selected:false},{permissionId:'5',selected:false},{permissionId:'6',selected:false},
          {permissionId:'7',selected:false},{permissionId:'8',selected:false},{permissionId:'9',selected:false},
          {permissionId:'10',selected:false},{permissionId:'11',selected:false},{permissionId:'12',selected:false},
          {permissionId:'13',selected:false},{permissionId:'14',selected:false},{permissionId:'15',selected:false},
          {permissionId:'16',selected:false},{permissionId:'17',selected:false},{permissionId:'18',selected:false},
          {permissionId:'19',selected:false},{permissionId:'20',selected:false},{permissionId:'21',selected:false},
          {permissionId:'22',selected:false},{permissionId:'23',selected:false},{permissionId:'24',selected:false},
          {permissionId:'25',selected:false},{permissionId:'26',selected:false},{permissionId:'27',selected:false},
          {permissionId:'28',selected:false},{permissionId:'29',selected:false},{permissionId:'30',selected:false},
          {permissionId:'31',selected:false},
        

    ],
    },
    defaultUser: {
      id: '',
      name: '',
      last_name: '',
      phone: '',
      address: '',
      nickname: '',
      job: '',
      email: '',
      password: null,
      image: null,
      permissions:[{permissionId:'1',selected:false},{permissionId:'2',selected:false},{permissionId:'3',selected:false},
          {permissionId:'4',selected:false},{permissionId:'5',selected:false},{permissionId:'6',selected:false},
          {permissionId:'7',selected:false},{permissionId:'8',selected:false},{permissionId:'9',selected:false},
          {permissionId:'10',selected:false},{permissionId:'11',selected:false},{permissionId:'12',selected:false},
          {permissionId:'13',selected:false},{permissionId:'14',selected:false},{permissionId:'15',selected:false},
          {permissionId:'16',selected:false},{permissionId:'17',selected:false},{permissionId:'18',selected:false},
          {permissionId:'19',selected:false},{permissionId:'20',selected:false},{permissionId:'21',selected:false},
          {permissionId:'22',selected:false},{permissionId:'23',selected:false},{permissionId:'24',selected:false},
          {permissionId:'25',selected:false},{permissionId:'26',selected:false},{permissionId:'27',selected:false},
          {permissionId:'28',selected:false},{permissionId:'29',selected:false},{permissionId:'30',selected:false},
          {permissionId:'31',selected:false},
        

    ],
    },
    options: {
        prefix: {
          blocks: [3, 3, 4],
          uppercase: true,
        },
    },
    lockedSubmit:{
        name:true,
        last_name:true,
        phone:true,
        address:true,
        job:true,
        username:true,
        email:true,
      },
    
    preview: null,
    image:null,
    baseURL:'http://quantumdaily-back.test/storage/',
    errors:[]
  }),
  methods: {
    previewImage(e) {
      this.image=null
      const file = e.target.files[0];
      this.preview = URL.createObjectURL(file);
    },
    updateUser() {

        let datos = new FormData();
        datos.append("id", this.user.id);
        datos.append("name", this.user.name);
        datos.append("last_name", this.user.last_name);
        datos.append("phone", this.user.phone);
        datos.append("address", this.user.address);
        datos.append("nickname", this.user.nickname);
        datos.append("job", this.user.job);
        datos.append("email", this.user.email);
        datos.append("permissions", JSON.stringify(this.user.permissions));
        if(this.user.password){
          datos.append("password", this.user.password);
        }
        if(this.user.image){
          datos.append("image", this.user.image);
        }
        datos.append("_method", "PUT");

        this.$swal({
          title: '¿Está seguro de guardar los cambios?',
          text: "No podrás revertir esto!",
          icon: 'warning',
          showCancelButton: true,
          confirmButtonText: 'Si, Guardar!',
          customClass: {
            confirmButton: 'btn btn-primary',
            cancelButton: 'btn btn-outline-danger ml-1',
          },
          buttonsStyling: false,

        }).then(result => {
          if (result.value) {
            this.$http.post("usuarios/edit", datos).then((res) => {
              if (res.data.message === "modificado") {
                this.$swal({
                  icon: 'success',
                  title: 'Guardado!',
                  text: 'El registro ha sido modificado.',
                  customClass: {
                    confirmButton: 'btn btn-success',
                  },
                })
                this.user = { ...this.defaultUser };
                this.$router.push({ name: "apps-users-list" });
              }else{
               
                if(res.data.errors){
                  this.errors = res.data.errors
                }
               
                this.$swal({
                  title: 'Error!',
                  text: ' No se pudo modificar!',
                  icon: 'error',
                  customClass: {
                    confirmButton: 'btn btn-primary',
                  },
                  buttonsStyling: false,
                })
              }
            }).catch((error) => {
              console.log(error);
            });
          } else if (result.dismiss === 'cancel') {
            this.$swal({
              title: 'Cancelado',
              text: 'No se registraron cambios :)',
              icon: 'error',
              customClass: {
                confirmButton: 'btn btn-success',
              },
            })
          }
        })
    

    },
    getUser(){
      this.user.id = this.$route.params.id;
      let parametros = {
        id: this.user.id,
      };
      this.$http.get("usuarios/show", { params: parametros }).then((res) => {
        // console.log(res.data);
        this.user.name = res.data.user.name;
        this.user.last_name = res.data.user.last_name;
        this.user.phone = res.data.user.phone;
        this.user.address = res.data.user.address;
        this.user.job = res.data.user.job;
        this.user.nickname = res.data.user.nickname;
        this.user.email = res.data.user.email;
        this.image = res.data.user.image;

        let permissions_request = res.data.user.permissions
        let user_permissions = this.user.permissions

        permissions_request.forEach( function(valor, indice, array) {
            user_permissions.forEach( function(data, indice2, array2) {
              if(data.permissionId == valor.id){
                    data.selected = true
                }
            });
        });

      }).catch((error) => {
        console.log(error);
      });
    },
  
  },
    computed:{
    validationName(){

      if(this.user.name.length > 0 ){
        this.lockedSubmit.name = false
        return true
      }else{
        this.lockedSubmit.name = true
        return false
      }
    },
    validationLastName(){
      if(this.user.last_name.length > 0 ){
        this.lockedSubmit.last_name = false
        return true
      }else{
        this.lockedSubmit.last_name = true
        return false
      }
    },
    validationPhone(){
     
      if (this.user.phone !== '') {
        if(/^[1-9]{10}/.test(this.user.phone)){
          this.lockedSubmit.phone = false
          return true
        }else{
          this.lockedSubmit.phone = true
          return false;
        }
      } else {
          this.lockedSubmit.phone = true
          return false;
      }
      
    },
    validationAddress(){
      if( this.user.address.length > 0 ){
        this.lockedSubmit.address = false
        return true
      }else{
        this.lockedSubmit.address = true
        return false
      }
    },
    validationJob(){
 
      if(this.user.job.length > 0 ){
        this.lockedSubmit.job = false
        return true
      }else{
        this.lockedSubmit.job = true
        return false
      }
    },
  validationUsername(){
  
    if(this.user.nickname.length > 0){
      this.lockedSubmit.username = false
      return true
    }else{
      this.lockedSubmit.username = true
      return false
    }
    
  },
  validationEmail(){

       
    if (this.user.email !== '') {
      // var patt = new RegExp("/^[\w-\.]+@([\w-]+\.)+[\w-]{2,4}$/");
      if(/^[\w-\.]+@([\w-]+\.)+[\w-]{2,4}$/.test(this.user.email)){
        this.lockedSubmit.email = false
        return true
      }else{
          this.lockedSubmit.email = true
        return false;
      }
    } else {
          this.lockedSubmit.email = true
        return false;
    }
        
  },

  },
  mounted() {
    this.getUser()

  },
};
</script>



<style >
</style>
